#ifndef MSP_GL_WINDINGTEST_H_
#define MSP_GL_WINDINGTEST_H_

#include <msp/strings/lexicalcast.h>
#include "bindable.h"
#include "gl.h"

namespace Msp {
namespace GL {

enum FaceWinding
{
	CLOCKWISE = GL_CW,
	COUNTERCLOCKWISE = GL_CCW
};

void operator>>(const LexicalConverter &, FaceWinding &);

/**
Tests the winding of polygons.  If the order of vertices on screen does not
match the winding, the polygon is not rendered.
*/
class WindingTest: public Bindable<WindingTest>
{
private:
	FaceWinding winding;

public:
	WindingTest();
	WindingTest(FaceWinding);

	void bind() const;

	static void unbind();

	const WindingTest &get_reverse() const;

	static const WindingTest &clockwise();
	static const WindingTest &counterclockwise();
};

} // namespace GL
} // namespace Msp

#endif
